package jcg.zheng.demo.log4j2;

import org.apache.logging.log4j.core.LogEvent;
import org.apache.logging.log4j.core.config.plugins.Plugin;
import org.apache.logging.log4j.core.pattern.ConverterKeys;
import org.apache.logging.log4j.core.pattern.LogEventPatternConverter;

@Plugin(name = "logmask", category = "Converter")
@ConverterKeys(value = { "cm" })
public class MaskLog extends LogEventPatternConverter {

	public MaskLog(String[] options) {
		super("cm", "cm");
	}

	public static MaskLog newInstance(final String[] options) {
		return new MaskLog(options);
	}

	@Override
	public void format(LogEvent logEvent, StringBuilder outputMsg) {
		String message = logEvent.getMessage().getFormattedMessage();
		if (message != null && message.contains("Password")) {
			String finalMsg = message.replaceAll("Password=.*", "Password=***");
			outputMsg.append(finalMsg);
		} else {
			outputMsg.append(message);
		}
	}

}
